﻿using System;
using System.Collections;
using System.Windows.Markup;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq; 

namespace XMLBinderDemo
{
    public class XMLBinderExtension : MarkupExtension
    {
        public string Source { get; set; }
        public string Path { get; set; }
        private static List<string> Parse(string file, string path)
        {
            XDocument xdoc = XDocument.Load(file);
            string[] text = path.Substring(1).Split('/');
            string desc = text[0].ToString();
            string elementname = text[1].ToString();
            List<string> data = new List<string>();
            IEnumerable<XElement> elems = xdoc.Descendants(desc);
            IEnumerable<XElement> elem_list = from elem in elems
                                              select elem;
            foreach (XElement element in elem_list)
            {
                String str0 = element.Attribute(elementname).Value.ToString();
                data.Add(str0);
            }
            return data;
        }
        /// <summary>
        /// Overridden method that returns the source and path to bind to
        /// </summary>
        /// <param name="serviceProvider"></param>
        /// <returns></returns>
        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            if ((Source != null) && (Path != null))
                return Parse(Source, Path);
            else
                throw new InvalidOperationException("Inputs cannot be blank");
        }
    }
}