﻿using System.Windows.Controls;
using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Windows.Navigation;
using System;

namespace CollectionsDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            Employees emps = new Employees();
            InitializeComponent();
            PagedCollectionView pg = new PagedCollectionView(emps);
            pg.GroupDescriptions.Add(new PropertyGroupDescription("Designation"));
            dgEmps.DataContext = pg;

            //Uncomment this to run the filter
            //pg.Filter = new Predicate<object>(PerformFilter);
        }


        //Callback method
        private bool PerformFilter(object o)
        {
            // it is not a case sensitive search
            Employee emp = o as Employee;
            if (emp != null)
            {
                if (emp.Designation == "Manager")
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            return false;
        }
    }





    public class Employees : ObservableCollection<Employee>
    {
        public Employees()
            : base()
        {
            Add(new Employee() { Name = "John Evans", Designation = "Manager" });
            Add(new Employee() { Name = "Dylan Miller", Designation = "Accountant" });
            Add(new Employee() { Name = "David Bristol", Designation = "Manager" });
            Add(new Employee() { Name = "Oliver Kiel", Designation = "Programmer" });
            Add(new Employee() { Name = "Jill Shrader", Designation = "Programmer" });
            Add(new Employee() { Name = "Prakash Paramasivam", Designation = "Programmer" });
        }
    }
    public class Employee
    {
        public string Name { get; set; }
        public string Designation { get; set; }
    }
}