﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.Windows.Annotations;
using System.Windows.Annotations.Storage;
using System.Windows.Xps;
using System.Windows.Xps.Packaging;
using System.IO;

namespace FormsFunctionalControls
{
    /// <summary>
    /// Interaction logic for StickyNote.xaml
    /// </summary>
    public partial class StickyNote : Window
    {
        public StickyNote()
        {
            InitializeComponent();
        }

        private void documentview_Loaded(object sender, RoutedEventArgs e)
        {
            XpsDocument xpsdocument = new XpsDocument("C:/Users/aghoda/Documents/Books/XAML/Projects/Chapter7/XPSSample.xps", FileAccess.Read);

            FixedDocumentSequence fds = xpsdocument.GetFixedDocumentSequence();

            documentview.Document = fds;

            StartAnnotations();

            documentview.Focus();
        }

        private AnnotationService _annotService = null;
        private FileStream _annotStream = null;
        private XmlStreamStore _annotStore = null;
        private readonly string _annotStorePath = @"annotations.xml";

        private void StartAnnotations()
        {
            // If there is no AnnotationService yet, create one.
            if (_annotService == null)
                // docViewer is a document viewing control named in Window1.xaml.
                _annotService = new AnnotationService(documentview);

            // If the AnnotationService is currently enabled, disable it.
            if (_annotService.IsEnabled == true)
                _annotService.Disable();

            // Open a stream to the file for storing annotations.
            _annotStream = new FileStream(
                _annotStorePath, FileMode.OpenOrCreate, FileAccess.ReadWrite);

            // Create an AnnotationStore using the file stream.
            _annotStore = new XmlStreamStore(_annotStream);

            // Enable the AnnotationService using the new store.
            _annotService.Enable(_annotStore);
        }
    }
}
